]> Git Repo - linux.git/blob - scripts/rust_is_available.sh
Merge tag 'soc-drivers-6.14' of git://git.kernel.org/pub/scm/linux/kernel/git/soc/soc
[linux.git] / scripts / rust_is_available.sh
1 #!/bin/sh
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Tests whether a suitable Rust toolchain is available.
5
6 set -e
7
8 min_tool_version=$(dirname $0)/min-tool-version.sh
9
10 # Convert the version string x.y.z to a canonical up-to-7-digits form.
11 #
12 # Note that this function uses one more digit (compared to other
13 # instances in other version scripts) to give a bit more space to
14 # `rustc` since it will reach 1.100.0 in late 2026.
15 get_canonical_version()
16 {
17         IFS=.
18         set -- $1
19         echo $((100000 * $1 + 100 * $2 + $3))
20 }
21
22 # Print a reference to the Quick Start guide in the documentation.
23 print_docs_reference()
24 {
25         echo >&2 "***"
26         echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
27         echo >&2 "*** on how to set up the Rust support."
28         echo >&2 "***"
29 }
30
31 # Print an explanation about the fact that the script is meant to be called from Kbuild.
32 print_kbuild_explanation()
33 {
34         echo >&2 "***"
35         echo >&2 "*** This script is intended to be called from Kbuild."
36         echo >&2 "*** Please use the 'rustavailable' target to call it instead."
37         echo >&2 "*** Otherwise, the results may not be meaningful."
38         exit 1
39 }
40
41 # If the script fails for any reason, or if there was any warning, then
42 # print a reference to the documentation on exit.
43 warning=0
44 trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
45
46 # Check that the expected environment variables are set.
47 if [ -z "${RUSTC+x}" ]; then
48         echo >&2 "***"
49         echo >&2 "*** Environment variable 'RUSTC' is not set."
50         print_kbuild_explanation
51 fi
52
53 if [ -z "${BINDGEN+x}" ]; then
54         echo >&2 "***"
55         echo >&2 "*** Environment variable 'BINDGEN' is not set."
56         print_kbuild_explanation
57 fi
58
59 if [ -z "${CC+x}" ]; then
60         echo >&2 "***"
61         echo >&2 "*** Environment variable 'CC' is not set."
62         print_kbuild_explanation
63 fi
64
65 # Check that the Rust compiler exists.
66 if ! command -v "$RUSTC" >/dev/null; then
67         echo >&2 "***"
68         echo >&2 "*** Rust compiler '$RUSTC' could not be found."
69         echo >&2 "***"
70         exit 1
71 fi
72
73 # Check that the Rust bindings generator exists.
74 if ! command -v "$BINDGEN" >/dev/null; then
75         echo >&2 "***"
76         echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
77         echo >&2 "***"
78         exit 1
79 fi
80
81 # Check that the Rust compiler version is suitable.
82 #
83 # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
84 rust_compiler_output=$( \
85         LC_ALL=C "$RUSTC" --version 2>/dev/null
86 ) || rust_compiler_code=$?
87 if [ -n "$rust_compiler_code" ]; then
88         echo >&2 "***"
89         echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
90         echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
91         echo >&2 "***"
92         echo >&2 "$rust_compiler_output"
93         echo >&2 "***"
94         exit 1
95 fi
96 rust_compiler_version=$( \
97         echo "$rust_compiler_output" \
98                 | sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
99 )
100 if [ -z "$rust_compiler_version" ]; then
101         echo >&2 "***"
102         echo >&2 "*** Running '$RUSTC' to check the Rust compiler version did not return"
103         echo >&2 "*** an expected output. See output and docs below for details:"
104         echo >&2 "***"
105         echo >&2 "$rust_compiler_output"
106         echo >&2 "***"
107         exit 1
108 fi
109 rust_compiler_min_version=$($min_tool_version rustc)
110 rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
111 rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
112 if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
113         echo >&2 "***"
114         echo >&2 "*** Rust compiler '$RUSTC' is too old."
115         echo >&2 "***   Your version:    $rust_compiler_version"
116         echo >&2 "***   Minimum version: $rust_compiler_min_version"
117         echo >&2 "***"
118         exit 1
119 fi
120
121 # Check that the Rust bindings generator is suitable.
122 #
123 # Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
124 #
125 # The dummy parameter `workaround-for-0.69.0` is required to support 0.69.0
126 # (https://github.com/rust-lang/rust-bindgen/pull/2678) and 0.71.0
127 # (https://github.com/rust-lang/rust-bindgen/pull/3040). It can be removed when
128 # the minimum version is upgraded past the latter (0.69.1 and 0.71.1 both fixed
129 # the issue).
130 rust_bindings_generator_output=$( \
131         LC_ALL=C "$BINDGEN" --version workaround-for-0.69.0 2>/dev/null
132 ) || rust_bindings_generator_code=$?
133 if [ -n "$rust_bindings_generator_code" ]; then
134         echo >&2 "***"
135         echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
136         echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
137         echo >&2 "***"
138         echo >&2 "$rust_bindings_generator_output"
139         echo >&2 "***"
140         exit 1
141 fi
142 rust_bindings_generator_version=$( \
143         echo "$rust_bindings_generator_output" \
144                 | sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
145 )
146 if [ -z "$rust_bindings_generator_version" ]; then
147         echo >&2 "***"
148         echo >&2 "*** Running '$BINDGEN' to check the bindings generator version did not return"
149         echo >&2 "*** an expected output. See output and docs below for details:"
150         echo >&2 "***"
151         echo >&2 "$rust_bindings_generator_output"
152         echo >&2 "***"
153         exit 1
154 fi
155 rust_bindings_generator_min_version=$($min_tool_version bindgen)
156 rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
157 rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
158 if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
159         echo >&2 "***"
160         echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
161         echo >&2 "***   Your version:    $rust_bindings_generator_version"
162         echo >&2 "***   Minimum version: $rust_bindings_generator_min_version"
163         echo >&2 "***"
164         exit 1
165 fi
166 if [ "$rust_bindings_generator_cversion" -eq 6600 ] ||
167         [ "$rust_bindings_generator_cversion" -eq 6601 ]; then
168         # Distributions may have patched the issue (e.g. Debian did).
169         if ! "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_0_66.h >/dev/null; then
170                 echo >&2 "***"
171                 echo >&2 "*** Rust bindings generator '$BINDGEN' versions 0.66.0 and 0.66.1 may not"
172                 echo >&2 "*** work due to a bug (https://github.com/rust-lang/rust-bindgen/pull/2567),"
173                 echo >&2 "*** unless patched (like Debian's)."
174                 echo >&2 "***   Your version:     $rust_bindings_generator_version"
175                 echo >&2 "***"
176                 warning=1
177         fi
178 fi
179
180 # Check that the `libclang` used by the Rust bindings generator is suitable.
181 #
182 # In order to do that, first invoke `bindgen` to get the `libclang` version
183 # found by `bindgen`. This step may already fail if, for instance, `libclang`
184 # is not found, thus inform the user in such a case.
185 bindgen_libclang_output=$( \
186         LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
187 ) || bindgen_libclang_code=$?
188 if [ -n "$bindgen_libclang_code" ]; then
189         echo >&2 "***"
190         echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
191         echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
192         echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
193         echo >&2 "***"
194         echo >&2 "$bindgen_libclang_output"
195         echo >&2 "***"
196         exit 1
197 fi
198
199 # `bindgen` returned successfully, thus use the output to check that the version
200 # of the `libclang` found by the Rust bindings generator is suitable.
201 #
202 # Unlike other version checks, note that this one does not necessarily appear
203 # in the first line of the output, thus no `sed` address is provided.
204 bindgen_libclang_version=$( \
205         echo "$bindgen_libclang_output" \
206                 | sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
207 )
208 if [ -z "$bindgen_libclang_version" ]; then
209         echo >&2 "***"
210         echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
211         echo >&2 "*** bindings generator) did not return an expected output. See output"
212         echo >&2 "*** and docs below for details:"
213         echo >&2 "***"
214         echo >&2 "$bindgen_libclang_output"
215         echo >&2 "***"
216         exit 1
217 fi
218 bindgen_libclang_min_version=$($min_tool_version llvm)
219 bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
220 bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
221 if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
222         echo >&2 "***"
223         echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
224         echo >&2 "***   Your version:    $bindgen_libclang_version"
225         echo >&2 "***   Minimum version: $bindgen_libclang_min_version"
226         echo >&2 "***"
227         exit 1
228 fi
229
230 if [ "$bindgen_libclang_cversion" -ge 1900100 ] &&
231         [ "$rust_bindings_generator_cversion" -lt 6905 ]; then
232         # Distributions may have patched the issue (e.g. Debian did).
233         if ! "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang_concat.h | grep -q foofoo; then
234                 echo >&2 "***"
235                 echo >&2 "*** Rust bindings generator '$BINDGEN' < 0.69.5 together with libclang >= 19.1"
236                 echo >&2 "*** may not work due to a bug (https://github.com/rust-lang/rust-bindgen/pull/2824),"
237                 echo >&2 "*** unless patched (like Debian's)."
238                 echo >&2 "***   Your bindgen version:  $rust_bindings_generator_version"
239                 echo >&2 "***   Your libclang version: $bindgen_libclang_version"
240                 echo >&2 "***"
241                 warning=1
242         fi
243 fi
244
245 # If the C compiler is Clang, then we can also check whether its version
246 # matches the `libclang` version used by the Rust bindings generator.
247 #
248 # In the future, we might be able to perform a full version check, see
249 # https://github.com/rust-lang/rust-bindgen/issues/2138.
250 cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
251 if [ "$cc_name" = Clang ]; then
252         clang_version=$( \
253                 LC_ALL=C $CC --version 2>/dev/null \
254                         | sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
255         )
256         if [ "$clang_version" != "$bindgen_libclang_version" ]; then
257                 echo >&2 "***"
258                 echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
259                 echo >&2 "*** version does not match Clang's. This may be a problem."
260                 echo >&2 "***   libclang version: $bindgen_libclang_version"
261                 echo >&2 "***   Clang version:    $clang_version"
262                 echo >&2 "***"
263                 warning=1
264         fi
265 fi
266
267 # Check that the source code for the `core` standard library exists.
268 #
269 # `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
270 rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
271 rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
272 rustc_src_core="$rustc_src/core/src/lib.rs"
273 if [ ! -e "$rustc_src_core" ]; then
274         echo >&2 "***"
275         echo >&2 "*** Source code for the 'core' standard library could not be found"
276         echo >&2 "*** at '$rustc_src_core'."
277         echo >&2 "***"
278         exit 1
279 fi
This page took 0.047087 seconds and 4 git commands to generate.